VARIABLES IN PL/SQL
----------------------

PL/SQL BLOCK STRUCTURE
------------------------

DECLARE
  ....
BEGIN
  ....
  ....
  ....
EXCEPTION
  ....
END;

EXAMPLES:
--------

DECLARE 
	SALARY REAL:= 1.00;
	TODAY DATE;
BEGIN
	 SALARY:= 2.0;
	 TODAY := SYSDATE;
END;


-- ERROR
DECLARE
  NAME VARCHAR2(3);
BEGIN
  SELECT *  
  FROM HR.EMPLOYEES;
END;


DECLARE
  XXX VARCHAR2(3);
BEGIN
  SELECT 'ABC'
  INTO XXX
  FROM DUAL;
END;

TYPE OF VARIABLES: SCALAR, COMPOSITE, REFERENCE, LOB
-----------------------------------------------------

MAIN DATA TYPES
----------------

CHAR
VARCHAR2
LONG
LONG RAW
NUMBER(PRECISION, SCALE)
BINARY_INTEGER
BOOLEAN
DATE

EXAMPLES:
---------
DECLARE
  v_job         VARCHAR2(9);
  v_count       INTEGER               := 0;
  v_total_sal   NUMBER(9,2)           := 0;
  c_orderdate   DATE                  := SYSDATE + 7;
  c_tax_rate    CONSTANT NUMBER(3,2)  := 8.25;
  v_valid       BOOLEAN NOT NULL      := TRUE;
BEGIN
  v_job  := 'A';
END;

  ....
  
THE %TYPE ATTRIBUTE
--------------------

<variable>  <TABLE>.<COLUMN_NAME>%TYPE;

DECLARE
  v_name   HR.EMPLOYEES.LAST_NAME%TYPE;
  id       HR.COUNTRIES.COUNTRY_ID%TYPE;
BEGIN
  SELECT LAST_NAME
  INTO v_name
  FROM HR.EMPLOYEES
  WHERE EMPLOYEE_ID = 100;

  SELECT COUNTRY_ID
  INTO id
  FROM HR.COUNTRIES
  WHERE COUNTRY_ID = 'BR';

END;
  

TABLES ARE COMPOSITE DATA TYPES
---------------------------------

BIND VARIABLES
--------------

VARIABLE <name> <datetype>

USE : TO ASSIGN AND PRINT TO SHOW THE VALUE
----------------------------------------------

EXAMPLE IN SQL*PLUS
--------------------

VARIABLE v_salary NUMBER;

BEGIN
  
  :v_salary := 10;
  
END;
/
PRINT v_salary;


VARIABLE v_salary NUMBER
BEGIN
  
  SELECT salary
  INTO :v_salary
  FROM HR.EMPLOYEES
  WHERE EMPLOYEE_ID = 100;

END;
/
PRINT v_salary

NORMAL VARIABLES x BIND VARIABLES x HOST VARIABLES
--------------------------------------------------

VARIABLE BIND_V NUMBER;
DEFINE    HOST_V = 100;

DECLARE
  NORMAL_V NUMBER(9,2) := &HOST_V;
BEGIN
  :BIND_V := 10;
END;
/
PRINT BIND_V;

SHOWING THE VALUE FOR A NORMAL VARIABLE
----------------------------------------

---> NOTE: ENABLE THE SERVEROUTPUT PARAMETER IN SQLPLUS
---> set serveroutput on;


DECLARE 
	SALARY REAL:= 1.00;
	TODAY DATE;
BEGIN
	 SALARY:= 2.0;
	 TODAY := SYSDATE;
	 DBMS_OUTPUT.PUT_LINE('Salary:' || TO_CHAR(SALARY));
	 DBMS_OUTPUT.PUT_LINE('Today:' || TO_CHAR(TODAY));
	 
END;
